const prefStringClick2TabBookmark = "click2tab.tab.bookmark";
const prefStringClick2TabHistory = "click2tab.tab.history";
const prefStringClick2TabUseMiddleClick = "click2tab.tab.useMiddleClick";
const prefStringClick2TabClearHistory = "click2tab.tab.clearHistory";
const prefStringClick2TabCtlWCloseTab = "click2tab.tab.ctlWCloseTab";

const prefStringClick2TabReopenInBackground = "click2tab.tab.reopenInBackground";
const prefStringClick2TabClosedCacheSize = "click2tab.tab.closedCacheSize";

function isBookmarklet(aSelection, aDS)
{
    if (aSelection && aSelection.length == 1)
    {
        var jsURL = /^ *javascript:/;
        return jsURL.test(BookmarksUtils.getProperty(aSelection.item[0], NC_NS+"URL", aDS));
    }
    else
        return false;
}

// Based on the preference settings, change the browserTarget accordingly to open item in new tab
// when current tab isn't blank
function whereToOpenLinkClick2Tab(aEvent, prefString, aSelection, aDS)
{
    var browserTarget = whereToOpenLink(aEvent);

    var prefService = Components.classes['@mozilla.org/preferences-service;1']
                                .getService(Components.interfaces.nsIPrefService).getBranch(null);
    if (prefService.getBoolPref(prefString) && !isBookmarklet(aSelection, aDS))
        if (prefService.getBoolPref(prefStringClick2TabUseMiddleClick) && (aEvent.button == 1))
            browserTarget = "current";
        else
        {
            var w = getTopWin();
            var gBrowser = w.document.getElementById("content");
            if ((browserTarget == "current") && gBrowser.mCurrentBrowser.currentURI.spec != "about:blank")
                browserTarget = "tab";
        }

    return browserTarget;
}